searchNodes=[{"ref":"Ecto.Adapters.Neo4j.html","title":"Ecto.Adapters.Neo4j","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.html#autogenerate/1","title":"Ecto.Adapters.Neo4j.autogenerate/1","type":"function","doc":"Called to autogenerate a value for id/embed_id/binary_id. Returns the autogenerated value, or nil if it must be autogenerated inside the storage or raise if not supported. Callback implementation for Ecto.Adapter.Schema.autogenerate/1."},{"ref":"Ecto.Adapters.Neo4j.html#batch_query/4","title":"Ecto.Adapters.Neo4j.batch_query/4","type":"function","doc":"Execute given query in batch. There is two type of batches: :basic will use LIMIT to loop until every node is touched :with_skip will use SKIP and LIMIT until every node is touched In order to work, the query must contains: for :basic, LIMIT {limit} for :with_skip, SKIP {skip} LIMIT {limit} in any case: RETURN COUNT(my_nodes) AS nb_touched_nodes with my_nodes being the nodes you&#39;re working on The LIMIT is set by default to 10_000, but you can set your aown value via the option :chunk_size Example # :basic example iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; LIMIT ...&gt; {limit} ...&gt; DETACH DELETE n ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql) {:ok, []} # :with_skip example iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; ORDER BY ...&gt; n.nodeId ...&gt; SKIP ...&gt; {skip} ...&gt; LIMIT ...&gt; {limit} ...&gt; SET ...&gt; n.value = {new_value} ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql, %{new_value: 5}, :with_skip) {:ok, []} # :basic example with `chunk_size` option specifiedd iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; LIMIT ...&gt; {limit} ...&gt; DETACH DELETE n ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql, %{}, :basic, chunk_size: 20_000) {:ok, []}"},{"ref":"Ecto.Adapters.Neo4j.html#batch_query!/4","title":"Ecto.Adapters.Neo4j.batch_query!/4","type":"function","doc":"Same as batch_query!/4 but raises in case of error."},{"ref":"Ecto.Adapters.Neo4j.html#checkout/3","title":"Ecto.Adapters.Neo4j.checkout/3","type":"function","doc":"Checks out a connection for the duration of the given function. In case the adapter provides a pool, this guarantees all of the code inside the given fun runs against the same connection, which might improve performance by for instance allowing multiple related calls to the datastore to share cache information: Repo.checkout(fn -&gt; for _ &lt;- 100 do Repo.insert!(%Post{}) end end) If the adapter does not provide a pool, just calling the passed function and returning its result are enough. If the adapter provides a pool, it is supposed to &quot;check out&quot; one of the pool connections for the duration of the function call. Which connection is checked out is not passed to the calling function, so it should be done using a stateful method like using the current process&#39; dictionary, process tracking, or some kind of other lookup method. Make sure that this stored connection is then used in the other callbacks implementations, such as Ecto.Adapter.Queryable and Ecto.Adapter.Schema. Callback implementation for Ecto.Adapter.checkout/3."},{"ref":"Ecto.Adapters.Neo4j.html#delete/4","title":"Ecto.Adapters.Neo4j.delete/4","type":"function","doc":"Deletes a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.delete/4."},{"ref":"Ecto.Adapters.Neo4j.html#dumpers/2","title":"Ecto.Adapters.Neo4j.dumpers/2","type":"function","doc":"Returns the dumpers for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of dumpers with the given type usually at the beginning. This allows developers to properly translate values coming from the Ecto into adapter ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def dumpers(:boolean, type), do: [type, &amp;bool_encode/1] def dumpers(_primitive, type), do: [type] defp bool_encode(false), do: {:ok, 0} defp bool_encode(true), do: {:ok, 1} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def dumpers(:binary_id, type), do: [type, Ecto.UUID] def dumpers(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.dumpers/2."},{"ref":"Ecto.Adapters.Neo4j.html#ensure_all_started/2","title":"Ecto.Adapters.Neo4j.ensure_all_started/2","type":"function","doc":"Ensure all applications necessary to run the adapter are started. Callback implementation for Ecto.Adapter.ensure_all_started/2."},{"ref":"Ecto.Adapters.Neo4j.html#execute/6","title":"Ecto.Adapters.Neo4j.execute/6","type":"function","doc":"See Ecto.Adapters.Neo4j.Behaviour.Queryable.execute/6."},{"ref":"Ecto.Adapters.Neo4j.html#execute_ddl/3","title":"Ecto.Adapters.Neo4j.execute_ddl/3","type":"function","doc":"See Ecto.Adapters.Neo4j.Storage.Migrator.execute_ddl/3."},{"ref":"Ecto.Adapters.Neo4j.html#in_transaction?/1","title":"Ecto.Adapters.Neo4j.in_transaction?/1","type":"function","doc":"Returns true if the given process is inside a transaction. Callback implementation for Ecto.Adapter.Transaction.in_transaction?/1."},{"ref":"Ecto.Adapters.Neo4j.html#init/1","title":"Ecto.Adapters.Neo4j.init/1","type":"function","doc":"Initializes the adapter supervision tree by returning the children and adapter metadata. Callback implementation for Ecto.Adapter.init/1."},{"ref":"Ecto.Adapters.Neo4j.html#insert/3","title":"Ecto.Adapters.Neo4j.insert/3","type":"function","doc":"Insert data into database and create relationship if necessary."},{"ref":"Ecto.Adapters.Neo4j.html#insert/6","title":"Ecto.Adapters.Neo4j.insert/6","type":"function","doc":"Inserts a single new struct in the data store. Autogenerate The primary key will be automatically included in returning if the field has type :id or :binary_id and no value was set by the developer or none was autogenerated by the adapter. Callback implementation for Ecto.Adapter.Schema.insert/6."},{"ref":"Ecto.Adapters.Neo4j.html#insert!/3","title":"Ecto.Adapters.Neo4j.insert!/3","type":"function","doc":"Same as insert/3 but raises in case of error."},{"ref":"Ecto.Adapters.Neo4j.html#insert_all/7","title":"Ecto.Adapters.Neo4j.insert_all/7","type":"function","doc":"Inserts multiple entries into the data store. In case an Ecto.Query given as any of the field values by the user, it will be sent to the adapter as a tuple with in the shape of {query, params}. Callback implementation for Ecto.Adapter.Schema.insert_all/7."},{"ref":"Ecto.Adapters.Neo4j.html#loaders/2","title":"Ecto.Adapters.Neo4j.loaders/2","type":"function","doc":"Returns the loaders for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of loaders with the given type usually at the end. This allows developers to properly translate values coming from the adapters into Ecto ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def loaders(:boolean, type), do: [&amp;bool_decode/1, type] def loaders(_primitive, type), do: [type] defp bool_decode(0), do: {:ok, false} defp bool_decode(1), do: {:ok, true} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def loaders(:binary_id, type), do: [Ecto.UUID, type] def loaders(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.loaders/2."},{"ref":"Ecto.Adapters.Neo4j.html#lock_for_migrations/4","title":"Ecto.Adapters.Neo4j.lock_for_migrations/4","type":"function","doc":"See Ecto.Adapters.Neo4j.Storage.Migrator.lock_for_migrations/4."},{"ref":"Ecto.Adapters.Neo4j.html#preload/3","title":"Ecto.Adapters.Neo4j.preload/3","type":"function","doc":"See Ecto.Adapters.Neo4j.Behaviour.Repo.preload/3."},{"ref":"Ecto.Adapters.Neo4j.html#prepare/2","title":"Ecto.Adapters.Neo4j.prepare/2","type":"function","doc":"Commands invoked to prepare a query for all, update_all and delete_all. The returned result is given to execute/6. Callback implementation for Ecto.Adapter.Queryable.prepare/2."},{"ref":"Ecto.Adapters.Neo4j.html#query/3","title":"Ecto.Adapters.Neo4j.query/3","type":"function","doc":"Execute given query on the databsse. This will return a Bolt.Sips.Response. Example iex&gt; cql = &quot;RETURN {num} AS n&quot; iex&gt; params = %{num: 5} ...&gt; {:ok, ...&gt; %Bolt.Sips.Response{ ...&gt; bookmark: _, ...&gt; fields: [&quot;n&quot;], ...&gt; notifications: [], ...&gt; plan: nil, ...&gt; profile: nil, ...&gt; records: [[5]], ...&gt; results: [%{&quot;n&quot; =&gt; 5}], ...&gt; stats: [], ...&gt; type: &quot;r&quot; ...&gt; }} = Ecto.Adapters.Neo4j.query(cql, params) iex&gt; :ok :ok"},{"ref":"Ecto.Adapters.Neo4j.html#query!/3","title":"Ecto.Adapters.Neo4j.query!/3","type":"function","doc":"Same as query/3 but raises in case of error."},{"ref":"Ecto.Adapters.Neo4j.html#rollback/2","title":"Ecto.Adapters.Neo4j.rollback/2","type":"function","doc":"Rolls back the current transaction. The transaction will return the value given as {:error, value}. See Ecto.Repo.rollback/1. Callback implementation for Ecto.Adapter.Transaction.rollback/2."},{"ref":"Ecto.Adapters.Neo4j.html#storage_down/1","title":"Ecto.Adapters.Neo4j.storage_down/1","type":"function","doc":"Drops the storage given by options. Returns :ok if it was dropped successfully. Returns {:error, :already_down} if the storage has already been dropped or {:error, term} in case anything else goes wrong. Examples storage_down(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_down/1."},{"ref":"Ecto.Adapters.Neo4j.html#storage_up/1","title":"Ecto.Adapters.Neo4j.storage_up/1","type":"function","doc":"Creates the storage given by options. Returns :ok if it was created successfully. Returns {:error, :already_up} if the storage has already been created or {:error, term} in case anything else goes wrong. Examples storage_up(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_up/1."},{"ref":"Ecto.Adapters.Neo4j.html#stream/5","title":"Ecto.Adapters.Neo4j.stream/5","type":"function","doc":"Streams a previously prepared query. It returns a stream of values. The adapter_meta field is a map containing some of the fields found in the Ecto.Query struct. Callback implementation for Ecto.Adapter.Queryable.stream/5."},{"ref":"Ecto.Adapters.Neo4j.html#supports_ddl_transaction?/0","title":"Ecto.Adapters.Neo4j.supports_ddl_transaction?/0","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.html#transaction/3","title":"Ecto.Adapters.Neo4j.transaction/3","type":"function","doc":"Runs the given function inside a transaction. Returns {:ok, value} if the transaction was successful where value is the value return by the function or {:error, value} if the transaction was rolled back where value is the value given to rollback/1. Callback implementation for Ecto.Adapter.Transaction.transaction/3."},{"ref":"Ecto.Adapters.Neo4j.html#update/3","title":"Ecto.Adapters.Neo4j.update/3","type":"function","doc":"Updates a changeset using its primary key. This alternative to Ecto.Repo.update takes care of relationships, therefore they can be added / deleted. Use put_assoc to update relationships. Example # Remove all relationship of a kind MyRepo.get!(User, &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;) |&gt; Ecto.Adapters.Neo4j.preload(:wrote_post) |&gt; Ecto.Changeset.change() |&gt; put_assoc(:wrote_post, []) |&gt; Ecto.Adapters.Neo4j.update() # Add a new relationship new_post = MyRepo.insert(%Post{title: &quot;New post&quot;}) user = MyRepo.get!(User, &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;) |&gt; Ecto.Adapters.Neo4j.preload(:wrote_post) user |&gt; Ecto.Changeset.change() |&gt; put_assoc(:wrote_post, user.wrote_post ++ [new_post]) |&gt; Ecto.Adapters.Neo4j.update()"},{"ref":"Ecto.Adapters.Neo4j.html#update/6","title":"Ecto.Adapters.Neo4j.update/6","type":"function","doc":"Updates a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.update/6."},{"ref":"Ecto.Adapters.Neo4j.html#update!/3","title":"Ecto.Adapters.Neo4j.update!/3","type":"function","doc":"Same as update3 but raises in case of error"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#batch_query/4","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.batch_query/4","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#batch_query!/4","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.batch_query!/4","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#checkout/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.checkout/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#execute/6","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.execute/6","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#get_conn/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.get_conn/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#in_transaction?/1","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.in_transaction?/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#prepare/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.prepare/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#query/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.query/3","type":"function","doc":"Launch the given query with params on database. Returns all found results, on raise a Bolt.Sips.Exception in case of error. As database errors should not be silently ignored, a wrong query will crash. Example Ecto.Adapters.Neo4j.Repo.query(&quot;MATCH (n:Post {uuid: {uuid}}&quot;, %{uuid: &quot;unique_id&quot;})"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#query!/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.query!/3","type":"function","doc":"Same as query but raises in case of error;"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#rollback/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.rollback/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#run_batch_query/1","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.run_batch_query/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#run_batch_query!/1","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.run_batch_query!/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#stream/6","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.stream/6","type":"function","doc":"Not implemented yet."},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#transaction/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.transaction/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Relationship.html","title":"Ecto.Adapters.Neo4j.Behaviour.Relationship","type":"module","doc":"Manage relationship operations"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Relationship.html#process_relationships/1","title":"Ecto.Adapters.Neo4j.Behaviour.Relationship.process_relationships/1","type":"function","doc":"Create the necessary relationships for the given schema data. Extract data from the has_many and has_one associations and convert them into relationships. Note that only 1-depth assocations are treated."},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Relationship.html#update/4","title":"Ecto.Adapters.Neo4j.Behaviour.Relationship.update/4","type":"function","doc":"Remove / add relationship. For this to work, has_one, has_many, belongs_to declaration must have the option on_replace: :delete. :update will add a new relationship (without its data, they will be added later during the update process) :replace will remove the relationship This function should not be called directly but through Ecto.Adapters.Neo4j.update/3 Example user = MyRepo.get!(User, user_uuid) post = MyRepo.get!(Post, post_uuid) # This will set the relationship (User)-[:WROTE]-&gt;(Post) update(:update, user, post, :wrote_post) # This will remove the relationship (User)-[:WROTE]-&gt;(Post) update(:delete, user, post, :wrote_post)"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Relationship.html#update_data/4","title":"Ecto.Adapters.Neo4j.Behaviour.Relationship.update_data/4","type":"function","doc":"Update relationship data. This function should not be called directly but through Ecto.Adapters.Neo4j.update/3"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Repo.html","title":"Ecto.Adapters.Neo4j.Behaviour.Repo","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Repo.html#preload/3","title":"Ecto.Adapters.Neo4j.Behaviour.Repo.preload/3","type":"function","doc":"Preloads all associations on the given struct or structs. Unsupported features: Nested associaiton preloads custom query preloads Examples # Use a single atom to preload an association posts = Repo.preload posts, :comments # Use a list of atoms to preload multiple associations posts = Repo.preload posts, [:comments, :authors]"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Repo.PreloadInfo.html","title":"Ecto.Adapters.Neo4j.Behaviour.Repo.PreloadInfo","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Repo.PreloadInfo.html#t:t/0","title":"Ecto.Adapters.Neo4j.Behaviour.Repo.PreloadInfo.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Condition.html","title":"Ecto.Adapters.Neo4j.Condition","type":"module","doc":"Reprensents an atomix WHERE clause"},{"ref":"Ecto.Adapters.Neo4j.Condition.html#join_conditions/3","title":"Ecto.Adapters.Neo4j.Condition.join_conditions/3","type":"function","doc":"Join 2 conditions in one with the given operator"},{"ref":"Ecto.Adapters.Neo4j.Condition.html#stringify_condition/1","title":"Ecto.Adapters.Neo4j.Condition.stringify_condition/1","type":"function","doc":"Converts Condition into a string in order to be used in query."},{"ref":"Ecto.Adapters.Neo4j.Condition.html#t:t/0","title":"Ecto.Adapters.Neo4j.Condition.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Condition.Node.html","title":"Ecto.Adapters.Neo4j.Condition.Node","type":"module","doc":"Hold node-specific operations on Ecto.Adapters.Neo4j.Condition."},{"ref":"Ecto.Adapters.Neo4j.Condition.Node.html#format/2","title":"Ecto.Adapters.Neo4j.Condition.Node.format/2","type":"function","doc":"Converts a Ecto.Adapters.Neo4j.Condition into clauses to be used in query building."},{"ref":"Ecto.Adapters.Neo4j.Condition.Node.html#t:clauses/0","title":"Ecto.Adapters.Neo4j.Condition.Node.clauses/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Condition.Relationship.html","title":"Ecto.Adapters.Neo4j.Condition.Relationship","type":"module","doc":"Hold relationships-specific operations on Ecto.Adapters.Neo4j.Condition."},{"ref":"Ecto.Adapters.Neo4j.Condition.Relationship.html#format/2","title":"Ecto.Adapters.Neo4j.Condition.Relationship.format/2","type":"function","doc":"Converts a Ecto.Adapters.Neo4j.Condition into clauses to be used in query building."},{"ref":"Ecto.Adapters.Neo4j.Condition.Relationship.html#t:clauses/0","title":"Ecto.Adapters.Neo4j.Condition.Relationship.clauses/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html","title":"Ecto.Adapters.Neo4j.Cql.Node","type":"module","doc":"Cypher query builder for Node"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_constraint/2","type":"function","doc":"Handle creation of unique constraints. Note that uniqueness on multiple properties is only available in Enterprise Edition Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint(&quot;Post&quot;, [:title]) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT n.title IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint(&quot;Post&quot;, [:title, :author]) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT (n.title, n.author) IS NODE KEY&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_constraint_index_from_cql/1","title":"Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql/1","type":"function","doc":"Builds a cypher for deleting a cosntraint or an index from the database. Required a constraint cql similar to the one provided by CALL db.constraints() Example iex&gt; constraint_cql = &quot;CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql(constraint_cql) &quot;CREATE CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; index_cql = &quot;INDEX ON :posts(nodeId)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql(index_cql) &quot;CREATE INDEX ON :posts(nodeId)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_index/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_index/2","type":"function","doc":"Handle creation of non unique indexes. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_index(&quot;Post&quot;, [:title]) &quot;CREATE INDEX ON :Post(title)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_index(&quot;Post&quot;, [:title, :author]) &quot;CREATE INDEX ON :Post(title, author)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_non_null_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_non_null_constraint/2","type":"function","doc":"Handle creation of non null constraints. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_non_null_constraint(&quot;Post&quot;, :title) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT exists(n.title)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete/2","title":"Ecto.Adapters.Neo4j.Cql.Node.delete/2","type":"function","doc":"Returns cypher query to delete a node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete(&quot;Post&quot;, %{uuid: &quot;a-valid-uuid&quot;}) {&quot;MATCH (n:Post) WHERE n.uuid = {uuid} DETACH DELETE n RETURN n &quot;, %{uuid: &quot;a-valid-uuid&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete_all/0","title":"Ecto.Adapters.Neo4j.Cql.Node.delete_all/0","type":"function","doc":"Returns cypher query to delete all database data. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete_all() &quot;MATCH (n) DETACH DELETE n &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete_nodes/1","title":"Ecto.Adapters.Neo4j.Cql.Node.delete_nodes/1","type":"function","doc":"Returns cypher query to delete all given nodes. This operation shoudl be performed as a btach for performance reason. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete_nodes(&quot;Post&quot;) &quot;MATCH (n:Post) WITH n AS n LIMIT {limit} DETACH DELETE n RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_constraint/2","type":"function","doc":"Handle deletion of unique constraints. Note that uniqueness on multiple properties is only available in Enterprise Edition Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint(&quot;Post&quot;, [:title]) &quot;DROP CONSTRAINT ON (n:Post) ASSERT n.title IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint(&quot;Post&quot;, [:title, :author]) &quot;DROP CONSTRAINT ON (n:Post) ASSERT (n.title, n.author) IS NODE KEY&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_constraint_index_from_cql/1","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql/1","type":"function","doc":"Builds a cypher for deleting a cosntraint or an index from the database. Required a constraint cql similar to the one provided by CALL db.constraints() Example iex&gt; constraint_cql = &quot;CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql(constraint_cql) &quot;DROP CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; index_cql = &quot;INDEX ON :posts(nodeId)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql(index_cql) &quot;DROP INDEX ON :posts(nodeId)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_index/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_index/2","type":"function","doc":"Handle deletion of non unique indexes. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_index(&quot;Post&quot;, [:title]) &quot;DROP INDEX ON :Post(title)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_index(&quot;Post&quot;, [:title, :author]) &quot;DROP INDEX ON :Post(title, author)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_non_null_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_non_null_constraint/2","type":"function","doc":"Handle deletion of non null constraints. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_non_null_constraint(&quot;Post&quot;, :title) &quot;DROP CONSTRAINT ON (n:Post) ASSERT exists(n.title)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#insert/4","title":"Ecto.Adapters.Neo4j.Cql.Node.insert/4","type":"function","doc":"Returns cypher query and params to insert a new node. Example iex&gt; data = %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.insert(&quot;Post&quot;, data, [:uuid]) {&quot;MERGE (n:Post {uuid: {uuid}}) ON CREATE SET n.title = {title}, \\nn.uuid = {uuid}\\n RETURN n &quot;, %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;}} # With returning fields specified iex&gt; data = %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.insert(&quot;Post&quot;, data, [:uuid], [:uuid]) {&quot;MERGE (n:Post {uuid: {uuid}}) ON CREATE SET n.title = {title}, \\nn.uuid = {uuid}\\n RETURN n.uuid AS uuid &quot;, %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#list_all_constraints/2","title":"Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints/2","type":"function","doc":"Builds a cypher query for listing all the constraints for a specific node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints(&quot;Post&quot;) &quot;CALL db.constraints() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; \\nRETURN description &quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints(&quot;Post&quot;, :title) &quot;CALL db.constraints() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; AND description CONTAINS &#39;.title&#39; RETURN description &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#list_all_indexes/2","title":"Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes/2","type":"function","doc":"Builds a cypher query for listing all the indexes for a specific node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes(&quot;Post&quot;) &quot;CALL db.indexes() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; \\nRETURN description &quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes(&quot;Post&quot;, :title) &quot;CALL db.indexes() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; AND description CONTAINS &#39;title&#39; RETURN description &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#relabel/2","title":"Ecto.Adapters.Neo4j.Cql.Node.relabel/2","type":"function","doc":"Build a query to relabel a node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.relabel(&quot;Post&quot;, &quot;NewPost&quot;) &quot;MATCH (n:Post) WITH n AS n LIMIT {limit} SET n:NewPost REMOVE n:Post RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#rename_property/3","title":"Ecto.Adapters.Neo4j.Cql.Node.rename_property/3","type":"function","doc":"Bulds a query to rename a property Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.rename_property(&quot;Post&quot;, &quot;titttle&quot;, &quot;title&quot;) &quot;MATCH (n:Post) WITH n AS n SKIP {skip} LIMIT {limit} SET n.title = n.titttle REMOVE n.titttle RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#update/3","title":"Ecto.Adapters.Neo4j.Cql.Node.update/3","type":"function","doc":"Returns cypher query to update node data. Example iex&gt; data = %{title: &quot;New title&quot;} iex&gt; filters = %{id: 5} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.update(&quot;Post&quot;, data, filters) {&quot;MATCH (n:Post) WHERE n.id = {f_id} SET n.title = {title} RETURN n &quot;, %{f_id: 5, title: &quot;New title&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Cql.Relationship.html","title":"Ecto.Adapters.Neo4j.Cql.Relationship","type":"module","doc":"Cypher query builder for Node"},{"ref":"Ecto.Adapters.Neo4j.Cql.Relationship.html#get_related/3","title":"Ecto.Adapters.Neo4j.Cql.Relationship.get_related/3","type":"function","doc":"Get cql to retrieve relationships between the two speccified nodes. Example iex&gt; where = &quot;n0.uuid = {uuid}&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Relationhip.get_related(&quot;User&quot;, &quot;Post&quot;, where) &quot;MATCH (n0:User)-[rel]-&gt;(n:Post) WHERE n0.uuid = {uuid} RETURN COLLECT(rel) AS relationships, n &quot;"},{"ref":"Ecto.Adapters.Neo4j.Helper.html","title":"Ecto.Adapters.Neo4j.Helper","type":"module","doc":"Useful helpers"},{"ref":"Ecto.Adapters.Neo4j.Helper.html#manage_id/2","title":"Ecto.Adapters.Neo4j.Helper.manage_id/2","type":"function","doc":"Manage id transformation from and to database. As Neo4j uses a field name id to store its internal id, the Ecto.Schema defined field id is transformed into nodeI to avoid any problem. Examples iex&gt; to_db_data = %{id: 3, value: &quot;test&quot;} iex&gt; from_db_data = Ecto.Adapters.Neo4j.Helper.manage_id(to_db_data, :to_db) %{nodeId: 3, value: &quot;test&quot;} iex&gt; Ecto.Adapters.Neo4j.Helper.manage_id(from_db_data, :from_db) %{id: 3, value: &quot;test&quot;}"},{"ref":"Ecto.Adapters.Neo4j.Helper.html#translate_field/2","title":"Ecto.Adapters.Neo4j.Helper.translate_field/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.html","title":"Ecto.Adapters.Neo4j.Query","type":"module","doc":"Ecto.Adapters.Neo4j.Query is designed to build Cypher queries programmatically. It has functions to build essential parts of a Cypher Query and its to_string returns a valid cypher query. Example # MATCH # (n:User) # WHERE # n.uuid = &quot;my-user-uid&quot; # RETURN # n alias Ecto.Adapters.Neo4j.Query node = %Query.NodeExpr{ index: 0, variable: &quot;n&quot;, labels: [&quot;User&quot;] } condition = %Ecto.Adapters.Neo4j.Condition{ source: node.variable, field: :uuid, operator: :==, value: &quot;user_uuid&quot; } params = %{ user_uuid: &quot;my-user-uid&quot; } return = %Query.ReturnExpr{ distinct?: false, fields: [ node ] } {cql, params} = Query.new() |&gt; Query.match([node]) |&gt; Query.where(condition) |&gt; Query.return(return) |&gt; Query.params(params) IO.puts(cql) &quot;MATCH\\n (n:User)\\n\\nWHERE\\n n.uuid = {user_uuid}\\n\\n\\n\\n\\n\\nRETURN\\n n\\n\\n\\n\\n\\n&quot; IO.inspect(params) %{user_uuid: &quot;my-user-uid&quot;}"},{"ref":"Ecto.Adapters.Neo4j.Query.html#batch/2","title":"Ecto.Adapters.Neo4j.Query.batch/2","type":"function","doc":"Adds information regarding batch query. See Ecto.Adapters.Neo4j.batch_query4 for more info about batch queries."},{"ref":"Ecto.Adapters.Neo4j.Query.html#delete/2","title":"Ecto.Adapters.Neo4j.Query.delete/2","type":"function","doc":"Adds DELETE data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#limit/2","title":"Ecto.Adapters.Neo4j.Query.limit/2","type":"function","doc":"Adds LIMIT data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#match/2","title":"Ecto.Adapters.Neo4j.Query.match/2","type":"function","doc":"Adds MATCH data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#merge/2","title":"Ecto.Adapters.Neo4j.Query.merge/2","type":"function","doc":"Adds MERGE data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#new/1","title":"Ecto.Adapters.Neo4j.Query.new/1","type":"function","doc":"Initilaize the Query struct"},{"ref":"Ecto.Adapters.Neo4j.Query.html#order_by/2","title":"Ecto.Adapters.Neo4j.Query.order_by/2","type":"function","doc":"Adds ORDER BY data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#params/2","title":"Ecto.Adapters.Neo4j.Query.params/2","type":"function","doc":"Adds params"},{"ref":"Ecto.Adapters.Neo4j.Query.html#return/2","title":"Ecto.Adapters.Neo4j.Query.return/2","type":"function","doc":"Adds RETLURN data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#set/2","title":"Ecto.Adapters.Neo4j.Query.set/2","type":"function","doc":"Adds SET data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#skip/2","title":"Ecto.Adapters.Neo4j.Query.skip/2","type":"function","doc":"Adds SKIP data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#to_string/1","title":"Ecto.Adapters.Neo4j.Query.to_string/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.html#where/2","title":"Ecto.Adapters.Neo4j.Query.where/2","type":"function","doc":"Adds WHERE data"},{"ref":"Ecto.Adapters.Neo4j.Query.html#t:entity_expr/0","title":"Ecto.Adapters.Neo4j.Query.entity_expr/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.AggregateExpr.html","title":"Ecto.Adapters.Neo4j.Query.AggregateExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.AggregateExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.AggregateExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.Batch.html","title":"Ecto.Adapters.Neo4j.Query.Batch","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.Batch.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.Batch.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.BatchExpr.html","title":"Ecto.Adapters.Neo4j.Query.BatchExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.BatchExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.BatchExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.CollectExpr.html","title":"Ecto.Adapters.Neo4j.Query.CollectExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.CollectExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.CollectExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.FieldExpr.html","title":"Ecto.Adapters.Neo4j.Query.FieldExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.FieldExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.FieldExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.MergeExpr.html","title":"Ecto.Adapters.Neo4j.Query.MergeExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.MergeExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.MergeExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.NodeExpr.html","title":"Ecto.Adapters.Neo4j.Query.NodeExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.NodeExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.NodeExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.OrderExpr.html","title":"Ecto.Adapters.Neo4j.Query.OrderExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.OrderExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.OrderExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.RelationshipExpr.html","title":"Ecto.Adapters.Neo4j.Query.RelationshipExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.RelationshipExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.RelationshipExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.ReturnExpr.html","title":"Ecto.Adapters.Neo4j.Query.ReturnExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.ReturnExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.ReturnExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.SetExpr.html","title":"Ecto.Adapters.Neo4j.Query.SetExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.SetExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.SetExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.ValueExpr.html","title":"Ecto.Adapters.Neo4j.Query.ValueExpr","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Query.ValueExpr.html#t:t/0","title":"Ecto.Adapters.Neo4j.Query.ValueExpr.t/0","type":"type","doc":""},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html","title":"Ecto.Adapters.Neo4j.QueryMapper","type":"module","doc":"Mapper that converts an Ecto.Query struct into a Ecto.Adapters.Neo4j.Query one."},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map/4","title":"Ecto.Adapters.Neo4j.QueryMapper.map/4","type":"function","doc":"Map Ecto.Query to Ecto.Adapters.Neo4j.Query"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_distinct/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_distinct/1","type":"function","doc":"Map EctoQuery distinct clause to a Neo4j.Query compliant one."},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_from/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_from/1","type":"function","doc":"Converts EctoQuery.sources into an Ecto.Adapters.Neo4j.Query compliant list of NodeExpr which would be used in MATCH"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_join/2","title":"Ecto.Adapters.Neo4j.QueryMapper.map_join/2","type":"function","doc":"Map join into Neo4j.Query compliant relationship query. on will be used to define filters. Note that every realtionship filters have to be specified as on clauses"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_limit/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_limit/1","type":"function","doc":"Map EctoQuery.limit to Neo4j.Query compliant ones."},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_offset/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_offset/1","type":"function","doc":"Map EctoQuery.order_bys to Neo4j.Query compliant value to be used in SKIP."},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_order_by/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_order_by/1","type":"function","doc":"Map EctoQuery.order_bys to Neo4j.Query compliant ones."},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_preload/4","title":"Ecto.Adapters.Neo4j.QueryMapper.map_preload/4","type":"function","doc":"Produce a Neo4j.Query to retrieve relationship (mapping of the ecto preload operation)"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_query/4","title":"Ecto.Adapters.Neo4j.QueryMapper.map_query/4","type":"function","doc":"Map a non-preload Ecto.Query to Ecto.Adapters.Neo4j.Query"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_select/1","title":"Ecto.Adapters.Neo4j.QueryMapper.map_select/1","type":"function","doc":"Map Ecto.Query.select to Neo4j.Query list of return (nodes, relationships o fields) which will be used in RETURN"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_update/3","title":"Ecto.Adapters.Neo4j.QueryMapper.map_update/3","type":"function","doc":"Map EctoQuery.updates to Neo4j.Query list of Sets which will be used in SETs.§"},{"ref":"Ecto.Adapters.Neo4j.QueryMapper.html#map_where/3","title":"Ecto.Adapters.Neo4j.QueryMapper.map_where/3","type":"function","doc":"Map EctoQuery.wheres to Neo4j.Condition which will used to build WHERE clauses."},{"ref":"Ecto.Adapters.Neo4j.Schema.html","title":"Ecto.Adapters.Neo4j.Schema","type":"module","doc":"Helps to describe graph schema. -&gt; Adds :uuid as default primary key -&gt; Provides 2 helpers to manage relationship: outgoing_relationship incoming relationship"},{"ref":"Ecto.Adapters.Neo4j.Schema.html#build_foreign_key/1","title":"Ecto.Adapters.Neo4j.Schema.build_foreign_key/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Schema.html#incoming_relationship/3","title":"Ecto.Adapters.Neo4j.Schema.incoming_relationship/3","type":"macro","doc":"Decribe a incoming relationship for current Ecto.Schema to given Ecto.Schema IMPORTANT: association name has to be formated as : [relationship_name]_[child_schema_name] an outgoing_relationship with the exact same name has to be added in the parent schema. Example # Describes a relationship: (User)-[:WROTE]-&gt;(Post) schema &quot;Post&quot; do incoming_relationship :wrote_post, EctoNeo4j.Integration.User end Options :unique: set to true, the association will be a has_one. Set to false, association will be has_many. [Default: false]"},{"ref":"Ecto.Adapters.Neo4j.Schema.html#outgoing_relationship/3","title":"Ecto.Adapters.Neo4j.Schema.outgoing_relationship/3","type":"macro","doc":"Decribe a outgoing relationship for current Ecto.Schema to given Ecto.Schema IMPORTANT: association name has to be formated as : [relationship_name]_[child_schema_name] an incoming_relationship with the exact same name has to be added in the child schema. Example # Describes a relationship: (User)-[:WROTE]-&gt;(Post) schema &quot;User&quot; do outgoing_relationship :wrote_post, EctoNeo4j.Integration.Post end Options :unique: set to true, the association will be a has_one. Set to false, association will be has_many. [Default: false]"},{"ref":"Ecto.Adapters.Neo4j.Storage.html","title":"Ecto.Adapters.Neo4j.Storage","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.html#storage_down/1","title":"Ecto.Adapters.Neo4j.Storage.storage_down/1","type":"function","doc":"Drops the storage given by options. Returns :ok if it was dropped successfully. Returns {:error, :already_down} if the storage has already been dropped or {:error, term} in case anything else goes wrong. Examples storage_down(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_down/1."},{"ref":"Ecto.Adapters.Neo4j.Storage.html#storage_up/1","title":"Ecto.Adapters.Neo4j.Storage.storage_up/1","type":"function","doc":"Creates the storage given by options. Returns :ok if it was created successfully. Returns {:error, :already_up} if the storage has already been created or {:error, term} in case anything else goes wrong. Examples storage_up(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_up/1."},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html","title":"Ecto.Adapters.Neo4j.Storage.Migrator","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html#execute_ddl/3","title":"Ecto.Adapters.Neo4j.Storage.Migrator.execute_ddl/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html#lock_for_migrations/4","title":"Ecto.Adapters.Neo4j.Storage.Migrator.lock_for_migrations/4","type":"function","doc":""},{"ref":"readme.html","title":"Ecto adapter for Neo4j graph database","type":"extras","doc":"Ecto adapter for Neo4j graph database Goal EctoNeo4j is designed to ease the use of Neo4j in elixir and provides an adapter for Ecto.It allows to works with schema and to use the classic Ecto.Repo functions. Kepp in mind that Ecto.Schema is relational-database oriented, then some graph-specific operations have to be emulated with the Ecto terms, especially join, assoc, preload."},{"ref":"readme.html#installation","title":"Ecto adapter for Neo4j graph database - Installation","type":"extras","doc":"Add ecto and ecto_neo4j to your dependencies: def deps do [ {:ecto, &quot;~&gt; 3.2&quot;}, {:ecto_sql, &quot;~&gt; 3.2&quot;}, {:ecto_neo4j, &quot;~&gt; 0.6&quot;} ] end ecto_sql is required if you planned to use the migration features. Configuration Configuration is very similar to other adapters: # In your config/config.exs file config :my_app, ecto_repos: [MyApp.Repo] # In your env-specific config, define database config (see bolt_sips for more information): config :my_app, MyApp.Repo, hostname: &#39;localhost&#39;, basic_auth: [username: &quot;user&quot;, password: &quot;pass&quot;], port: 7687, pool_size: 5, max_overflow: 1 # In your application code defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Neo4j end Knowns limitations"},{"ref":"readme.html#ecto-is-designed-for-relational-database-but-neo4j-is-a-graph-database","title":"Ecto adapter for Neo4j graph database - Ecto is designed for relational database but Neo4j is a graph database","type":"extras","doc":"Then not all of Ecto features are available in EctoNeo4j, either because they don&#39;t have their counterparts in Cypher Neo4j or because they don&#39;t make sense in Neo4j.As an effeot to have a usable package, Ecto feature like join, assoc, etc. are used to manage relationships. Usage"},{"ref":"readme.html#schema","title":"Ecto adapter for Neo4j graph database - Schema","type":"extras","doc":"Reserved field: id As you may know, Neo4j uses a feild named id toi manage its internal identifiers. It is then strongly recommended to not use it in your schemas. Defining schema To define a schema designed to be used with ECtoNeo4j, it is recommended to use Ecto.Adapters.Neo4j.Schema as it : provides a primary key named :uuid to avoid conflic with Neo4j internal identifiers provides 2 macros to manage relationships: outgoing_relationship/2 (and /3) and incoming_relationship/2 allows to not use has_* and belongs_to functions Note that many_to_many is not covered as its mangement is not possible yet. Relationships Relationships can be defined via: outgoing_relationship and incoming_relationship. outgoing_relationship takes 3 parameters: a name which is an atom formated as [relationshiptype][child_schema_name] the related schema [optional] the options. For now only :unique (bool) is available. It defiens wether many child nodes can be linked to parent node (unique: false, the default) or just one (unique: true) incoming_relationship takes 2 parameters: a name which is an atom formated as [relationshiptype][child_schema_name] the related schema Relationships properties are a field in child schema. This field must be named rel_[relationship_type] and is a map. Note that the name has to be the same in parent and child schema. Example Considering the following graph schema: (User)-[:WROTE]-&gt;(Post) (User)-(:READ)-&gt;(Post) (User)-[:HAS]-&gt;(Profile) where a User can read / wrote mutiple posts, but has only one profile. This tranlates as: defmodule MyApp.User do use Ecto.Adapters.Neo4j.Schema schema &quot;User&quot; do field :first_name, :string field :last_name, :string outgoing_relationship :has_userprofile, MyApp.UserProfil, unique: true outgoing_relationship(:wrote_post, MyApp.Post) outgoing_relationship :read_post, MyApp.Post end end defmodule MyApp.Profile do use Ecto.Adapters.Neo4j.Schema schema &quot;UserProfile&quot; do field :avatar, :string field :rel_has, :map incoming_relationship :has_profile, MyApp.User end end defmodule MyApp.Post do use Ecto.Adapters.Neo4j.Schema schema &quot;Post&quot; do field :title, :string field :text, :string field :rel_wrote, :map field :rel_read, :map incoming_relationship :wrote_post, MyApp.User incoming_relationship :read_post, MyApp.User end end"},{"ref":"readme.html#migration","title":"Ecto adapter for Neo4j graph database - Migration","type":"extras","doc":"All features work, but with some subtleties for some.One important thing if that all operations in migation are performed via batch. This means your migrations will be successfully executed regardless of your database size, but it can take some time. More on batch here. What you need to know about migrations: create table don&#39;t do anything as expected as Neo4j is schemaless drop table will remove all the specified nodes and all existing indexes / constraints primary_key will be transformed in a constraint CONSTRAINT ON(n:label) ASSERT n.property IS UNIQUE create index(label, properties, unique: true) will either create an unique constraint or a node key constraint (the latter is only supported by Entreprise Edition) create index(label, properties) will create a classic index rename table and rename col will move the existing constraints and indexes from the old entity to the new one"},{"ref":"readme.html#do-not-add-a-name-to-indexes-constraints","title":"Ecto adapter for Neo4j graph database - DO NOT ADD A NAME TO INDEXES / CONSTRAINTS","type":"extras","doc":"You have the possibility to give index/constraint a name via the option of create/3. Don&#39;t do it.First, Neo4j doesn&#39;t support named indexes/constraints. Because of this &quot;limitation&quot;, in case of uniqueness error or such, EctoNeo4j has to rebuild an index name, which it does considering the default index naming."},{"ref":"readme.html#repo","title":"Ecto adapter for Neo4j graph database - Repo","type":"extras","doc":"Most of Ecto.Repo features work then you are free to use the classic Repo.insert, Repo.one, Repo.transaction etc. Unsupported features Repo.stream (maybe soon) nested transaction: they don&#39;t exist in Neo4j Repo.checkout About Ecto.Query As you expect, none all Ecto.Query are available, here is a list of whan can be used: distinct dynamic first from which is MATCH in cypher join to manage relationships last limit offset which is SKIP in cypher order_by select which is RETURN in cypher update which is MATCH... SET in cypher where For very specific operation like CONTAINS, START_WITH, etc. I encourage you to use query fragment Working with relationships (associations in Ecto) When you ant to work on relationship, you have to use Neo4j&#39;s adapter specific functions and not the Ecto one. In fact, if you work with EctoNeo4j, it is recommedned to always use these functions instead of their Ecto counterparts.The specific funtions are: Ecto.Adapters.Neo4j.insert(repo, data, opts \\\\ []): creates nodes and creates relationship if required Ecto.Adapters.Neo4j.preload(struct_or_structs_or_nil, preloads, opts \\\\ []): usage and goal are the same as Repo.preload Ecto.Adapters.Neo4j.update(changeset, repo, opts \\\\ []): updates nodes and creates / removes / updates realtionships if needed The weird position of repo in the argument is to ease the piping. Inserting There is nothing special here, insert your data as you would do with classic Ecto associations. Updating / Deleting For this kind of operation, put_assoc has to be used. Querying Because relationship are not citizens in the relational world, Ecto does not provide the ability to query them. In order to retrieve relationship data, you will have to query the node in order to feed the relationship field (prefixed by rel_).To query a relationship, you can use join and on keywords. join allows you to specify the node to link, and on will have ALL clauses ti apply on relationship. Example: # Unspecified relationship from u in User, join: p in Post # will translates to: MATCH (u:User)-[]-&gt;(:Post) RETURN u # Beware of the multiple results? # Specific relationship (but without data) from u in User, join: p in Post, on: p.rel_wrote == ^%{} # will translates to: MATCH (u:User)-[:WROTE]-&gt;(:Post) RETURN u # Specific relationship (without data) from u in User, join: p in Post, on: p.rel_wrote == ^%{when: ~D[2019-12-12]} # will translates to: MATCH (u:User)-[rel:WROTE]-&gt;(:Post) WHERE rel.when = &quot;2019-12-12&quot; RETURN u # Non existing relationship: from u in User, join: p in Post, on: is_nil(p.rel_wrote) # will translates to: MATCH (u:User) WHERE NOT (u)-[:WROTE]-&gt;(:Post) RETURN u About update_all and delete_all Because theses two operations can touch a large number of nodes, you can have them be performed as batch via the option [batch: true].More on batch here."},{"ref":"readme.html#raw-cypher-query","title":"Ecto adapter for Neo4j graph database - Raw cypher query","type":"extras","doc":"Raw cypher queries can be executed thanks to Ecto.Adapters.Neo4j.query(cql, params, opts) and Ecto.Adapters.Neo4j.query!(cql, params, opts).They return a Bolt.Sips.Response if case of success Example: iex&gt; my_query = &quot;RETURN {num} AS num&quot; iex&gt; Ecto.Adapters.Neo4j.query(my_query, %{num: 5}) {:ok, %Bolt.Sips.Response{ bookmark: nil, fields: [&quot;num&quot;], notifications: [], plan: nil, profile: nil, records: [[5]], results: [%{&quot;num&quot; =&gt; 5}], stats: [], type: &quot;r&quot; }}"},{"ref":"readme.html#batch","title":"Ecto adapter for Neo4j graph database - Batch","type":"extras","doc":"Some updates or deletes can touch a large number of node and therefore required to be executed as batch in order to perform well (and to finish...).EctoNeo4j provides utility functions for this purpose: Ecto.Adapters.Neo4j.batch_query(cql, params, batch_type, opts) and Ecto.Adapters.Neo4j.batch_query!(cql, params, batch_type, opts).There is two types of batches and each require a specially formed query.They works on the same logic: execute a query count the touched nodes if the number of touched nodes is not 0 then back to 1 Batch types :basic The default batch type is :basic. Query must have: LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes.This batch type is usually used for delete operation.It is not required to provide the limit in your params, it will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- The `WITH` allows to work on a subset... n AS n &lt;--- LIMIT {limit} &lt;--- with the specified nuber of node DETACH DELETE &lt;--- Perform the desired operation n RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the number of nodes touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql) :with_skip This batch type is useful where a simple COUNT is irrevelant (in update operation for example). Query must have: SKIP {skip} LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes.It is not required to provide the skip nor the limit in your params, they will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- THe WITH allows to work on a subset... n AS n &lt;--- SKIP {skip} LIMIT {limit} &lt;--- with the specified nuber of node SET &lt;--- Perform the desired operation n.title = &quot;Updated: &quot; + n.title RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the number of nodes touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql, %{}, :with_skip) Chunk size The default chunk size is 10_000.The ideal chunk size is tighly related to the machine RAM, and you can specify if you want: at query level with the options [chunk_size: integer] Example: Ecto.Adapters.Neo4j.query(cql, params, :basic, [chunk_size: 50_000]) in your configuration, you can define the desired default chunk_size: config :ecto_neo4j, Ecto.Adapters.Neo4j, chunk_size: 50_000 update_all, delete_all You can have Repo.update_all and Repo.delete_all executed as batches with the option [batch: true] (without any query tricks).This option can be added in your configuration if you want the behaviour to happen for all update_alls and delete_alls. config :ecto_neo4j, Ecto.Adapters.Neo4j, batch: true TODO [ ] Remove the id to nodeId conversion [x] Manage bolt role[ ] Split test to allow bolt v1 testing[ ] Support prefix? (is there any use case for this?)[ ] Support optimistic locking?[x] Support migration (only: index creation, drop, rename, alter column name)[x] Migration is supposed to support large amount of data (use batch...)[ ] Support insert select?[ ] Support delete with returning?[ ] Support map update?[ ] Implement a merge?[ ] Telemetry[ ] insert_all performance [ ] stream [x] ecto.drop should remove constraints and indexes() Can I contribute? Yes, you can! Please, do!Just fork, commit and submit pull requests!"},{"ref":"up_and_running.html","title":"Up and running","type":"extras","doc":"Up and running The aim of this guide is to explain how EctoNeo4j works with a full example. Neo4j is required, so if you haven&#39;t installed it yet, get it at https://neo4j.com/download/. Be sure to have a running database with the following credentials: login: neo4j password: graph_app_pass"},{"ref":"up_and_running.html#unsupported-features","title":"Up and running - Unsupported features","type":"extras","doc":"Not all Ecto features are supported, either because they aren&#39;t implemented yet in EctoNeo4j or because they-re irrelevant in a graph context. Unsupported features: subqueries: complicated to translate them in WITH terms streams: will be supported migration: only some parts are supported, other are irrelevant as Neo4j is schemaless"},{"ref":"up_and_running.html#the-project-graphapp","title":"Up and running - The Project: GraphApp","type":"extras","doc":"We are going to build a backend to manage the data for a blog application.The model will be as follow: a User can only have one UserProfile.a User can write multiple Posts.a User can read multiple Posts. a User can write multiple Comments.a Post can have multiple Comments. User properties: firstName lastName UserProfile properties: avatarUrl age Post properties: title text Comment properties: text :WROTE (from User to Post, and from User to Comment) properties: when Create the application We create our supervised application via mix new --sup graph_app * creating README.md * creating .formatter.exs ... * creating test/graph_app_test.exs Your Mix project was created successfully. You can use &quot;mix&quot; to compile it, test it, and more: cd graph_app mix test Run &quot;mix help&quot; for more commands. Now, we can add our dependencies in mix.exs: # mix.exs defp deps do [ {:ecto, &quot;~&gt; 3.2&quot;}, {:ecto_sql, &quot;~&gt; 3.2&quot;}, {:ecto_neo4j, &quot;~&gt; 0.6&quot;} ] end and mix do deps get, compile Configuration It&#39;s time to define our Repo and to add its config.Open config/config.exs and add: # config/config.exs config :graph_app, ecto_repos: [GraphApp.Repo] We add the repo config (as we would do with any ecto adapters): # config/config.exs config :graph_app, GraphApp.Repo, hostname: &#39;localhost&#39;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;graph_app_pass&quot;], port: 7687 We create our repo module: # lib/graph_app/repo.ex defmodule GraphApp.Repo do use Ecto.Repo, otp_app: :graph_app, adapter: Ecto.Adapters.Neo4j end And we don&#39;t forget to add to our application supervisor: # lib/graph_app/application def start(_type, _args) do # List all child processes to be supervised children = [ GraphApp.Repo ] opts = [strategy: :one_for_one, name: GraphApp.Supervisor] Supervisor.start_link(children, opts) end Now, we can make our first query in iex to test that everything has been well configured: iex -S mix iex&gt; Ecto.Adapters.Neo4j.query!(&quot;RETURN 1 AS num&quot;) %Bolt.Sips.Response{ bookmark: &quot;neo4j:bookmark:v1:tx1&quot;, fields: [&quot;num&quot;], notifications: [], plan: nil, profile: nil, records: [[1]], results: [%{&quot;num&quot; =&gt; 1}], stats: [], type: &quot;r&quot; } Formating EctoNeo4j has functions with custom formating.Be sure to get these benefits by addin this to your .formatter.exs: # .formatter.exs ... import_deps: [:ecto_neo4j] ..."},{"ref":"schema.html","title":"Schema","type":"extras","doc":"Schema"},{"ref":"schema.html#general","title":"Schema - General","type":"extras","doc":"A graph is composed of two objects: node and relationship, each with its own specifities.Node has: one or more labels 0 or more properties Relationship has: one type 0 or more properties a direction Because of how ecto is designed, it is not possible for now to have more than one label per node. In order to ease the schema building, we can use Ecto.Adapters.Neo4j.Schema which is a layer on top of Ecto.Schema. It sets the default primary key to :uuid instead of :id to avoid problem with Neo4j&#39;s internal identifier&#39;s system. Describing relationships Additionally, Ecto.Adapters.Neo4j.Schema offers two macros to work with relationships: outgoing_relationship/2 and outgoing_relationship/3 allows to describe outgoing relationship. Their usage is the same has_* macros: they take a name as first parameter and the related schema as second parameter. The third parameter is for options, only one is available for now: :unique. Set to true, it indicates that the relationship is 1-1, set to false t&#39;s a 1-many relationship. incoming_relationship/2 allows to describe an incoming relationship. First parameter is the name, the eseond is the related schema. Note that the name is formated as: [lowercase_relationship_type][child_schema_name] and have to be the same in parent and child schema.For example: Considering (:Actor)-[:PLAYS_IN]-&gt;(:Movie), we will have: defmodule MyApp.Actor do schema &quot;Actor&quot; do ... outgoing_relationship :plays_in_movie, MyApp.Movie end end defmodule MyApp.Movie do schema &quot;Movie&quot; do ... outgoing_relationship :plays_in_movie, MyApp.Actor end end About relationship properties Relationship data will be in the child schema, and be fed when preload is used. It is recommended to: have the field name set to rel\\[lowercased_relationship_type] have field type set to :map This field is mandatory, even if there will be no properties to use. It is still useful for querying purpose."},{"ref":"schema.html#putting-up-the-graphapp-schemas","title":"Schema - Putting up the GraphApp schemas","type":"extras","doc":"Remember the model a User can only have one UserProfile.a User can write multiple Posts.a User can read multiple Posts. a User can write multiple Comments.a Post can have multiple Comments. User properties: firstName lastName UserProfile properties: avatarUrl age Post properties: title text Comment properties: text :WROTE (from User to Post, and from User to Comment) properties: when Now, let&#39;s write our schemas: User # lib/graph_app/account/user.ex defmodule GraphApp.Account.User do use Ecto.Adapters.Neo4j.Schema schema &quot;User&quot; do field :firstName, :string field :lastName, :string # (:User)-[:HAS]-&gt;(:UserProfile) # A user has only one UserProfile outgoing_relationship :has_userprofile, GraphApp.Account.UserProfile, unique: true # (:User)-[:WROTE]-&gt;(:Post) outgoing_relationship :wrote_post, GraphApp.Blog.Post # (:User)-[:READ]-&gt;(:Post) outgoing_relationship :read_post, GraphApp.Blog.Post # (:User)-[:READ]-&gt;(:Comment) outgoing_relationship :wrote_comment, GraphApp.Blog.Comment end end UserProfile # lib/graph_app/account/user_profile.ex defmodule GraphApp.Account.UserProfile do use Ecto.Adapters.Neo4j.Schema schema &quot;UserProfile&quot; do field :avatar, :string # Field for :HAS relationship&#39;s properties field :rel_has, :map # (:User)-[:HAS]-&gt;(:UserProfile) # Note that the name of relationship is the same as in GraphApp.Account.User incoming_relationship :has_userprofile, GraphApp.Account.User end end Post # lib/graph_app/blog/post.ex defmodule GraphApp.Blog.Post do use Ecto.Adapters.Neo4j.Schema schema &quot;Post&quot; do field :title, :string field :text, :string # Field for :WROTE relationship&#39;s properties field :rel_wrote, :map # Field for :READ relationship&#39;s properties field :rel_read, :map # (:User)-[:WROTE]-&gt;(:Post) incoming_relationship :wrote_post, GraphApp.Account.User # (:User)-[:READ]-&gt;(:Post) incoming_relationship :read_post, GraphApp.Account.User # (:Post)-[:HAS]-&gt;(:Comment) outgoing_relationship :has_comment, GraphApp.Blog.Comment end end Comment # lib/graph_app/blog/comment.ex defmodule GraphApp.Blog.Comment do use Ecto.Adapters.Neo4j.Schema schema &quot;Comment&quot; do field :text, :string # Field for :WROTE relationship&#39;s properties field :rel_wrote, :map # Field for :HAS relationship&#39;s properties field :rel_has, :map # (:User)-[:WROTE]-&gt;(:Comment) incoming_relationship :wrote_comment, GraphApp.Account.User # (:Post)-[:HAS]-&gt;(:Comment) incoming_relationship :has_comment, GraphApp.Blog.Post end end"},{"ref":"inserting.html","title":"Inserting","type":"extras","doc":"Inserting Inserting is similar as what it is in with Ecto, except that we have to use Ecto.Adapters.Neo4j.insert/3 instead of the classic insert/2 in order to have our relationships created."},{"ref":"inserting.html#inserting-nodes","title":"Inserting - Inserting nodes","type":"extras","doc":"It&#39;s straight forward as there is nothing more or less than in classic ecto. # Direct alias GraphApp.Account.User alias Ecto.Adapters.Neo4j user = %User{ uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, firstName: &quot;John&quot;, lastName: &quot;Doe&quot; } {:ok, user} = Neo4j.insert(GraphApp.Repo, user) # Result {:ok, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }} # Through changeset data = %{ uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, firstName: &quot;John&quot;, lastName: &quot;Doe&quot; } changeset = Ecto.Changeset.change(%User{}, data) {:ok, user} = Neo4j.insert(GraphApp.Repo, changeset) # Result {:ok, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }}"},{"ref":"inserting.html#inserting-nodes-and-relationships","title":"Inserting - Inserting nodes AND relationships","type":"extras","doc":"The only way to insert a lot of nodes and relationship at once required that we know the data to insert. Changeset won&#39;t work here.But it worths the shot as it allows us to insert a complete graph in one command! Just remember that relationship properties are set on child node. If no properties is required, just set the field to %{}.For example: comment1_data = %Comment{ uuid: &quot;2be39329-d9b5-4b85-a07f-ee9a2997a8ef&quot;, text: &quot;This a comment from john Doe&quot;, # These are the properties for the :WROTE relationship rel_wrote: %{when: ~D[2018-06-18]}, # These are the properties for the :HAS relationship rel_has: %{} } Now let&#39;s insert this graph: alias GraphApp.Account.{User, UserProfile} alias GraphApp.Blog.{Post, Comment} alias Ecto.Adapters.Neo4j comment1_data = %Comment{ uuid: &quot;2be39329-d9b5-4b85-a07f-ee9a2997a8ef&quot;, text: &quot;This a comment from john Doe&quot;, rel_wrote: %{when: ~D[2018-06-18]}, rel_has: %{} } comment2_data = %Comment{ uuid: &quot;e923428a-6819-47ab-bfef-ca4a2e9b75c3&quot;, text: &quot;This is not the best post I&#39;ve read...&quot;, rel_wrote: %{when: ~D[2018-07-01]}, rel_has: %{} } post1_data = %Post{ uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, title: &quot;First&quot;, text: &quot;This is the first&quot;, rel_wrote: %{ when: ~D[2018-01-01] }, has_comment: [ comment1_data, comment2_data ] } post2_data = %Post{ uuid: &quot;727289bc-ec28-4459-a9dc-a51ee6bfd6ab&quot;, title: &quot;Second&quot;, text: &quot;This is the second&quot;, rel_read: %{}, rel_wrote: %{ when: ~D[2018-02-01] } } user_profile = %UserProfile{ uuid: &quot;0f364433-c0d2-47ac-ad9b-1dc15bd40cde&quot;, avatar: &quot;user_avatar.png&quot;, rel_has: %{} } user = %User{ uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, firstName: &quot;John&quot;, lastName: &quot;Doe&quot;, read_post: [ post2_data ], wrote_post: [ post1_data, post2_data ], wrote_comment: [ comment1_data, comment2_data ], has_userprofile: user_profile } {:ok, user} = Neo4j.insert(GraphApp.Repo, user) # Result {:ok, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: %GraphApp.Account.UserProfile{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;UserProfile&quot;&gt;, avatar: &quot;user_avatar.png&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, has_userprofile_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, rel_has: %{}, uuid: &quot;0f364433-c0d2-47ac-ad9b-1dc15bd40cde&quot; }, lastName: &quot;Doe&quot;, read_post: [ %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, rel_read: %{}, rel_wrote: %{when: ~D[2018-02-01]}, text: &quot;This is the second&quot;, title: &quot;Second&quot;, uuid: &quot;727289bc-ec28-4459-a9dc-a51ee6bfd6ab&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: nil } ], uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: [ %GraphApp.Blog.Comment{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Comment&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, has_comment_uuid: nil, rel_has: %{}, rel_wrote: %{when: ~D[2018-06-18]}, text: &quot;This a comment from john Doe&quot;, uuid: &quot;2be39329-d9b5-4b85-a07f-ee9a2997a8ef&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_comment_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; }, %GraphApp.Blog.Comment{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Comment&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, has_comment_uuid: nil, rel_has: %{}, rel_wrote: %{when: ~D[2018-07-01]}, text: &quot;This is not the best post I&#39;ve read...&quot;, uuid: &quot;e923428a-6819-47ab-bfef-ca4a2e9b75c3&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_comment_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; } ], wrote_post: [ %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: [ %GraphApp.Blog.Comment{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Comment&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, has_comment_uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, rel_has: %{}, rel_wrote: %{when: ~D[2018-06-18]}, text: &quot;This a comment from john Doe&quot;, uuid: &quot;2be39329-d9b5-4b85-a07f-ee9a2997a8ef&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_comment_uuid: nil }, %GraphApp.Blog.Comment{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Comment&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, has_comment_uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, rel_has: %{}, rel_wrote: %{when: ~D[2018-07-01]}, text: &quot;This is not the best post I&#39;ve read...&quot;, uuid: &quot;e923428a-6819-47ab-bfef-ca4a2e9b75c3&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_comment_uuid: nil } ], read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: %{when: ~D[2018-01-01]}, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; }, %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: %{}, rel_wrote: %{when: ~D[2018-02-01]}, text: &quot;This is the second&quot;, title: &quot;Second&quot;, uuid: &quot;727289bc-ec28-4459-a9dc-a51ee6bfd6ab&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; } ] }} You can notice the presence of wrote_post_uuid, wrote_comment_uuid, etc. These are foreign keys and ecto requires them to work properly.But don&#39;t panic, they aren&#39;t persisted in database."},{"ref":"querying.html","title":"Querying","type":"extras","doc":"Querying"},{"ref":"querying.html#querying-nodes","title":"Querying - Querying nodes","type":"extras","doc":"Nothing specific here, we can use Ecto functions the same we do with other adapters. We can: Repo.get Repo.get_by Repo.all Repo.oneetc."},{"ref":"querying.html#preloading","title":"Querying - Preloading","type":"extras","doc":"To preload data, we need to use Ecto.Adapters.Neo4j.preload instead of classic Repo.preload. This function works the same way except for subqueries and nested preloads which aren&#39;t supported. Considering the graph inserted in the Inserting section, we can do this: alias Ecto.Adapters.Neo4j alias GraphApp.Repo alias GraphApp.Account.User Repo.get!(User, &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;) |&gt; Neo4j.preload(:wrote_post) # Result %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: [ %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:built, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: %{&quot;when&quot; =&gt; ~D[2018-02-01]}, text: &quot;This is the second&quot;, title: &quot;Second&quot;, uuid: &quot;727289bc-ec28-4459-a9dc-a51ee6bfd6ab&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; }, %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:built, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: %{&quot;when&quot; =&gt; ~D[2018-01-01]}, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; } ] }"},{"ref":"querying.html#querying-relationships-and-relationships-data","title":"Querying - Querying relationships and relationships&#39; data","type":"extras","doc":"To query realtionships and their data, we need to use join and on.join will simply define the relationship and translate in cypher as an unqualified relationship between 2 nodes.For example: from u in User, join: p in Post will translate to:(:User)-[]-&gt;(:Post) on allows to qualifies relationship and to had clauses on relationship data.Remember that relationship data are part of the end node schema. We will use this field to had clause on relationship type and data: rel_[relationship_type] == %{} will check that there is a relationship of type [relationship_type] between the two nodes is_nil(rel_[relationship_type]) will check that there is NOT a relationship of type [relationship_type] between the two nodes rel_[relationship_type] == %{rel_property: prop_value} will check that there is a relationship of type [relationship_type] between the two nodes AND that it has a property named rel_property with the given prop_value IMPORTANT: - Always make joins from start node to end node, the opposite way is not supported yet - Relationship works at 1-level depth only for the moment - `or` operator in `on` clause is not supported Examples alias Ecto.Adapters.Neo4j import Ecto.Query alias GraphApp.Repo alias GraphApp.Account.{User, UserProfile} alias GraphApp.Blog.{Post, Comment} Considering the graph inserted in the Inserting section. Retrieving users related to post in any kind of way: In Cypher: MATCH (u:User)-[]-&gt;(:Post) RETURN u In EctoNeo4j: query = from u in User, join: p in Post Repo.all(query) # Result [ %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; } ] Notice the duplication of node &quot;John Doe&quot; which happens also when you launch the querey in Neo4j... Retrieving users who wrote post In Cypher: MATCH (u:User)-[:WROTE]-&gt;(:Post) RETURN u In EctoNeo4j: query = from u in User, join: p in Post, on: p.rel_wrote == ^%{} Repo.all(query) # Result [ %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; } ] Retrieving posts wrote by user but not read: In Cypher: MATCH (:User)-[:WROTE]-&gt;(p:Post) WHERE NOT (:User)-[:READ]-&gt;(p) RETURN p In EctoNeo4j: query = from u in User, join: p in Post, on: p.rel_wrote == ^%{} and is_nil(p.rel_read), select: p Repo.all(query) # Result [ %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: nil, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: nil } ] Retrieving user who wrote a post at a specific date: In cypher: MATCH (u:User)-[rel:WROTE]-&gt;(:Post) WHERE rel.when = ~D[2018-01-01] RETURN u In EctoNeo4j: rel_data = %{when: ~D[2018-01-01]} query = from u in User, join: p in Post, on: p.rel_wrote == ^rel_data, select: [u, p] Repo.all(query) # Result [ [ %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: nil, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: nil } ] ]"},{"ref":"querying.html#raw-cyher-queries","title":"Querying - Raw cyher queries","type":"extras","doc":"Raw cypher queries can be executed thanks to Ecto.Adapters.Neo4j.query(cql, params, opts) and Ecto.Adapters.Neo4j.query!(cql, params, opts).They return a Bolt.Sips.Response if case of success Example: iex&gt; my_query = &quot;RETURN {num} AS num&quot; iex&gt; Ecto.Adapters.Neo4j.query(my_query, %{num: 5}) {:ok, %Bolt.Sips.Response{ bookmark: nil, fields: [&quot;num&quot;], notifications: [], plan: nil, profile: nil, records: [[5]], results: [%{&quot;num&quot; =&gt; 5}], stats: [], type: &quot;r&quot; }}"},{"ref":"updating_and_deleting.html","title":"Updating and deleting","type":"extras","doc":"Updating and deleting"},{"ref":"updating_and_deleting.html#updating-deleting-nodes","title":"Updating and deleting - Updating / Deleting nodes","type":"extras","doc":"Nothing special here, we just do what we&#39;re used to do with ecto"},{"ref":"updating_and_deleting.html#updating-relationship-data","title":"Updating and deleting - Updating relationship data","type":"extras","doc":"Updating relationship data is quite easy: we just need to update the rel\\[relationship_type]_ field in the end node and that&#39;s it! Example In cypher: MATCH (u:User)-[rel:WROTE]-&gt;(p:Post) WHERE u.firstName = &quot;John&quot; AND p.title = &quot;First&quot; SET rel.when = ~D[2020-01-09], rel.from = &quot;My Fairphone&quot; In EctoNeo4j: rel_data = %{ when: ~D[2020-01-09], from: &quot;My Fairphone&quot; } Repo.get_by!(Post, title: &quot;First&quot;) |&gt; Neo4j.preload(:wrote_post) |&gt; Ecto.Changeset.change(%{rel_wrote: rel_data}) |&gt; Neo4j.update(Repo) # Result {:ok, %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: %{&quot;from&quot; =&gt; &quot;My Fairphone&quot;, &quot;when&quot; =&gt; ~D[2020-01-09]}, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:built, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, wrote_post_uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot; }}"},{"ref":"updating_and_deleting.html#updating-relationship","title":"Updating and deleting - Updating relationship","type":"extras","doc":"We simply follow the two following rules: Work with put_assoc and work on the associaiton as a whole Use Ecto.Adapters.Neo4j.update instead of the classic Repo.update Examples So, our graph is like this: Let&#39;s rework it! alias Ecto.Adapters.Neo4j alias GraphApp.Repo alias GraphApp.Account.{User, UserProfile} alias GraphApp.Blog.{Post, Comment} Let&#39;s start by adding a new user new_user_data = %User{ uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;, firstName: &quot;Jack&quot;, lastName: &quot;Sparrow&quot; } new_user = Neo4j.insert!(Repo, new_user_data) # Result %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;Jack&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Sparrow&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; } Add a relationship between User &quot;Jack&quot; and Post &quot;First&quot; (from parent) In cypher: MATCH (u:User), (p:Post) WHERE u.firstName = &quot;Jack&quot; AND p.title = &quot;First&quot; MERGE (u)-[:WROTE]-&gt;(p) post = Repo.get_by!(Post, title: &quot;First&quot;) user = Repo.get_by!(User, firstName: &quot;Jack&quot;) |&gt; Neo4j.preload(:wrote_post) |&gt; Ecto.Changeset.change() |&gt; Ecto.Changeset.put_assoc(:wrote_post, [post]) |&gt; Neo4j.update # Result {:ok, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;Jack&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Sparrow&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: [ %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: nil, text: &quot;This is the first&quot;, title: &quot;First&quot;, uuid: &quot;ae830851-9e93-46d5-bbf7-23ab99846497&quot;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt;, wrote_post_uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot; } ] }} Here is our new graph state: Add a relationship between User &quot;Jack&quot; and Post &quot;Second&quot; (from child) with new relationship data In Cypher: MATCH (u:User), (p:Post) WHERE u.firstName = &quot;Jack&quot; AND p.title = &quot;First&quot; MERGE (u)-[rel:WROTE]-&gt;(p) In EctoNeo4j: rel_data = %{when: ~D[2020-01-09], from: &quot;My Fairphone&quot;} Repo.get_by!(Post, title: &quot;Second&quot;) |&gt; Neo4j.preload([:wrote_post]) |&gt; Ecto.Changeset.change() |&gt; Ecto.Changeset.put_assoc(:wrote_post, new_user) |&gt; Neo4j.update(Repo) # Result {:ok, %GraphApp.Blog.Post{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;Post&quot;&gt;, has_comment: #Ecto.Association.NotLoaded&lt;association :has_comment is not loaded&gt;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, read_post_uuid: nil, rel_read: nil, rel_wrote: %{&quot;from&quot; =&gt; &quot;My Fairphone&quot;, &quot;when&quot; =&gt; ~D[2020-01-09]}, text: &quot;This is the second&quot;, title: &quot;Second&quot;, uuid: &quot;727289bc-ec28-4459-a9dc-a51ee6bfd6ab&quot;, wrote_post: %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;Jack&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Sparrow&quot;, read_post: #Ecto.Association.NotLoaded&lt;association :read_post is not loaded&gt;, uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: #Ecto.Association.NotLoaded&lt;association :wrote_post is not loaded&gt; }, wrote_post_uuid: &quot;ec1741ba-28f2-47fc-8a96-a3c5e24c42da&quot; }} Here is how the graph looks like now: We can see that an intersting thing happened: the relationship with the user &quot;John&quot; has been automatically removed. But we can do it ourselves. Remove all relationhips between user &quot;Jon&quot; and posts In cypher: MATCH (u:User), (u)-[rel_wrote:WROTE]-&gt;(:Post), (u)-[rel_read:WROTE]-&gt;(:Post) WHERE u.firstName = &quot;John&quot; DELETE rel_wrote, rel_read In EctoNeo4j: Repo.get_by!(User, firstName: &quot;John&quot;) |&gt; Neo4j.preload([:wrote_post,:read_post]) |&gt; Ecto.Changeset.change() |&gt; Ecto.Changeset.put_assoc(:wrote_post, []) |&gt; Ecto.Changeset.put_assoc(:read_post, []) |&gt; Neo4j.update(Repo) #Result {:ok, %GraphApp.Account.User{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;User&quot;&gt;, firstName: &quot;John&quot;, has_userprofile: #Ecto.Association.NotLoaded&lt;association :has_userprofile is not loaded&gt;, lastName: &quot;Doe&quot;, read_post: [], uuid: &quot;12903da6-5d46-417b-9cab-bd82766c868b&quot;, wrote_comment: #Ecto.Association.NotLoaded&lt;association :wrote_comment is not loaded&gt;, wrote_post: [] }} Here is how the graph looks like now:"},{"ref":"updating_and_deleting.html#batch-queries","title":"Updating and deleting - Batch queries","type":"extras","doc":"Some updates or deletes can touch a large number of node and therefore required to be executed as batch in order to perform well (and to finish...).EctoNeo4j provides utility functions for this purpose: Ecto.Adapters.Neo4j.batch_query(cql, params, batch_type, opts) and Ecto.Adapters.Neo4j.batch_query!(cql, params, batch_type, opts).There is two types of batches and each require a specially formed query.They works on the same logic: execute a query count the touched nodes if the number of touched nodes is not 0 then back to 1 Batch types :basic The default batch type is :basic. Query must have: LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes.This batch type is usually used for delete operation.It is not required to provide the limit in your params, it will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- The `WITH` allows to work on a subset... n AS n &lt;--- LIMIT {limit} &lt;--- with the specified nuber of node DETACH DELETE &lt;--- Perform the desired operation n RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the number of nodes touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql) :with_skip This batch type is useful where a simple COUNT is irrevelant (in update operation for example). Query must have: SKIP {skip} LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes.It is not required to provide the skip nor the limit in your params, they will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- THe WITH allows to work on a subset... n AS n &lt;--- SKIP {skip} LIMIT {limit} &lt;--- with the specified nuber of node SET &lt;--- Perform the desired operation n.title = &quot;Updated: &quot; + n.title RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the number of nodes touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql, %{}, :with_skip) Chunk size The default chunk size is 10_000.The ideal chunk size is tighly related to the machine RAM, and you can specify if you want: at query level with the options [chunk_size: integer] Example: Ecto.Adapters.Neo4j.query(cql, params, :basic, [chunk_size: 50_000]) in your configuration, you can define the desired default chunk_size: config :ecto_neo4j, Ecto.Adapters.Neo4j, chunk_size: 50_000 update_all, delete_all You can have Repo.update_all and Repo.delete_all executed as batches with the option [batch: true] (without any query tricks).This option can be added in your configuration if you want the behaviour to happen for all update_alls and delete_alls. config :ecto_neo4j, Ecto.Adapters.Neo4j, batch: true"}]